Subject: Re: bug#70071: [FR] Provide official install scripts without requiring root, e.g., by making a static build possible

From: Eli Zaretskii <[email-masked]>
Date: Sun, 31 Mar 2024 12:31:15 +0300

> Cc: [email-masked]
> From: Rudi C <[email-masked]>
> Date: Sun, 31 Mar 2024 12:36:16 +0330
> 
> I discovered a tool called junest (https://github.com/fsquillace/junest) that appears to work for installing Emacs
> without root access.

I'm glad you found a solution for you.

> Given that many users do not have root access, it is crucial to provide an official, well-documented method for
> installing Emacs in such environments. Addressing this issue should take precedence over introducing new
> features, as it will significantly improve the user experience and make Emacs more accessible to a wider
> audience.

As already mentioned, such a method exists and is well-documented: use
the --prefix option of the configure script to install Emacs in a
directory to which you have access.

This is not specific to Emacs, btw: every package that is built using
Autoconf-produced configure script and Makefiles accepts the --prefix
option to specify where to install it.

> In the current state, recommending Emacs to new users can be difficult, as the installation process requires a
> considerable amount of Linux knowledge. By streamlining the installation process for non-root users, Emacs
> will become more user-friendly and attractive to newcomers.

Users who are not knowledgeable enough to install Emacs on their own
should use a distro, or ask someone else to help them.

> As for what this officially endorsed (and tested) way of installing emacs without root should be, I don't have the
> expertise. But perhaps GNU Guix could officially support a non-root mode, as it seems technically possible.

Please suggest this to the Guix folks.  It is possible they will
provide such a feature, if it isn't already provided.  I don't know
enough about Guix to tell more, sorry.

> Alternatively, the Emacs installation documentation could include instructions on using a non-root package
> manager like junest, which should be tested to ensure compatibility with Emacs.

Sorry, we cannot possibly advertise other packages for these jobs: we
don't have the manpower for tracking them and studying them.

And with that, I'm closing this bug report, since I think we have
already covered everything that is relevant to this issue.